unit hiColorBoxEx; { ColorBoxEx ver 5.50}

interface

{$I share.inc}

uses Windows,Kol,Share,WinList,Messages;

const
   NONE     = 0;
   SCALE    = 1;
   MOSAIC   = 2;
   GRADIENT = 3;

FullColor = 47;

ColorValues: array [0..FullColor - 1] of TColor = (
  clBlack,clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGray,
  clSilver,clRed,clLime,clYellow,clBlue,clFuchsia,clAqua,clWhite,
  clMoneyGreen,clSkyBlue,clCream,clMedGray,clActiveBorder,clActiveCaption,
  clAppWorkSpace,clBackground,clBtnFace,clBtnHighlight,clBtnShadow,    
  clBtnText,clCaptionText,clDefault,clGrayText,clHighlight,clHighlightText,
  clInactiveBorder,clInactiveCaption,clInactiveCaptionText,clInfoBk,
  clInfoText,clMenu,clMenuText,clNone,clScrollBar,cl3DDkShadow,
  cl3DLight,clWindow,clWindowFrame,clWindowText );

ColorNames: array [0..FullColor - 1] of String = (
  'Black','Maroon','Green','Olive','Navy','Purple','Teal','Gray',
  'Silver','Red','Lime','Yellow','Blue','Fuchsia','Aqua','White',
  'MoneyGreen','SkyBlue','Cream','MedGray','ActiveBorder','ActiveCaption',
  'AppWorkSpace','Background','BtnFace','BtnHighlight','BtnShadow',    
  'BtnText','CaptionText','Default','GrayText','Highlight','HighlightText',
  'InactiveBorder','InactiveCaption','InactiveCaptionText','InfoBk',
  'InfoText','Menu','MenuText','None','ScrollBar','3DDkShadow',
  '3DLight','Window','WindowFrame','WindowText' );


type
 ThiColorBoxEx = class(THIWinList)
   private
     FData: TData;
     ColorRange:integer;
     ColorArr:PArray;
     ColorSize:integer;
     fCustomColors:boolean;
     fColors:string;
     fFormatColor:byte;
     fFullColor:boolean;
     fColorSize:byte;
     fDefColor:TColor;
     fGradient:boolean;
     fFrame:boolean;     
     fBumpText:boolean;
     fDepthGradient:integer;
     fDepthBack:integer;
     fDarkColor:TColor;
     fLightColor:TColor;
     fDarkClrBack:TColor;
     fLightClrBack:TColor;
     fHorizontal:boolean;
     fColorFrame:TColor;
     fScaleImage:byte;
     fInversGrad:boolean;
     fInversBack:boolean;
     fInversClrTxt:boolean;
     fIndentImg:integer;
     fBackgroundImg:HBITMAP;

     BackgroundImg:HBITMAP;
     procedure InitBackgroundImg;     
     procedure InitList;
     function  _val_arr_get(Var Item:TData; var Val:TData):boolean;
     function  _val_arr_count:integer;
     procedure _OnClick( Sender: PObj );
     procedure _OnResize( Sender: PObj ); override;
     function  _OnMeasureItem( Sender: PObj; Idx: Integer ):Integer;
     function  _OnDrawItem( Sender: PObj; DC: HDC; const Rect: TRect; ItemIdx: Integer;
                            DrawAction: TDrawAction; ItemState: TDrawState ): Boolean;
   public

     property _prop_BackgroundImg:HBITMAP read fBackgroundImg write fBackgroundImg;

     property _prop_CustomColors:boolean  write fCustomColors;
     property _prop_Colors:string         write fColors;
     property _prop_FormatColor:byte      write fFormatColor;
     property _prop_FullColor:boolean     write fFullColor;
     property _prop_ColorSize:byte        write fColorSize;
     property _prop_DefColor:TColor       read fDefColor write fDefColor;
     property _prop_Gradient:boolean      write fGradient;
     property _prop_Frame:boolean         write fFrame;     
     property _prop_BumpText:boolean      write fBumpText;
     property _prop_DepthGradient:integer write fDepthGradient;
     property _prop_DepthBack:integer     write fDepthBack;
     property _prop_DarkColor:TColor      write fDarkColor;
     property _prop_LightColor:TColor     write fLightColor;
     property _prop_DarkClrBack:TColor    write fDarkClrBack;
     property _prop_LightClrBack:TColor   write fLightClrBack;
     property _prop_Horizontal:boolean    write fHorizontal;
     property _prop_ColorFrame:TColor     write fColorFrame;
     property _prop_ScaleImage:byte       write fScaleImage;
     property _prop_InversGrad:boolean    write fInversGrad;
     property _prop_InversBack:boolean    write fInversBack;
     property _prop_InversClrTxt:boolean  write fInversClrTxt;
     property _prop_IndentImg:integer     write fIndentImg;


     destructor Destroy; override;
     procedure Init; override;

     procedure _work_doFormatColor(var _Data:TData; Index:word);
     procedure _work_doFullColor(var _Data:TData; Index:word);
     procedure _work_doGradient(var _Data:TData; Index:word);
     procedure _work_doDepthGradient(var _Data:TData; Index:word);
     procedure _work_doFrame(var _Data:TData; Index:word);
     procedure _work_doDarkColor(var _Data:TData; Index:word);
     procedure _work_doLightColor(var _Data:TData; Index:word);
     procedure _work_doHorizontal(var _Data:TData; Index:word);
     procedure _work_doColorFrame(var _Data:TData; Index:word);
     procedure _work_doBumpText(var _Data:TData; Index:word);
     procedure _work_doBackgroundImg(var _Data:TData; Index:word);
     procedure _work_doInversClrTxt(var _Data:TData; Index:word);
     procedure _work_doInversGrad(var _Data:TData; Index:word);
     procedure _work_doInversBack(var _Data:TData; Index:word);
     procedure _work_doDarkClrBack(var _Data:TData; Index:word);
     procedure _work_doLightClrBack(var _Data:TData; Index:word);     
     procedure _work_doScaleImage(var _Data:TData; Index:word);
     procedure _work_doDepthBack(var _Data:TData; Index:word);
     procedure _work_doSelectColor(var _Data:TData; Index:word);
     procedure _work_doSelectName(var _Data:TData; Index:word);
     procedure _var_ColorArray(var _Data:TData; Index:word);
     procedure _var_Index(var _Data:TData; Index:word);     
     procedure _var_CurrentColor(var _Data:TData; Index:word);
  end;

implementation

//-----------------------       ----------------------

type

  AGRBQuad = array [0..0] of RGBQuad;
  PAGRBQuad = ^AGRBQuad;

  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;

  PColor = ^TColor;

function GetLightColor(Color: TColor; Light: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    (FFrom.R*100 + (255 - FFrom.R) * Light) div 100,
    (FFrom.G*100 + (255 - FFrom.G) * Light) div 100,
    (FFrom.B*100 + (255 - FFrom.B) * Light) div 100
  );
end;

function RGB2HTML (Color: TColor): string;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result:='#'+Int2Hex(FFrom.R, 2)+Int2Hex(FFrom.G, 2)+Int2Hex(FFrom.B, 2)
end;

function GetShadeColor(Color: TColor; Shade: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    Max(0, FFrom.R - Shade),
    Max(0, FFrom.G - Shade),
    Max(0, FFrom.B - Shade)
  );
end;

//******************************  **************************************
  
type
  COLOR16 = $0000..$FF00;
  TTriVertex = packed record
    x, y: DWORD;
    Red, Green, Blue, Alpha: COLOR16;
  end;
function GradientFill(DC: HDC; Vertex: Pointer; NumVertex: Cardinal;
                      Mesh: Pointer; NumMesh, Mode: DWORD): BOOL; stdcall;
                      external 'msimg32.dll' name 'GradientFill';

procedure _Gradient(Sender:PControl; DC:HDC; cbRect:TRect; Gradient:boolean; DepthGradient:integer;
                    StartColor,EndColor,ColorFrame:TColor; Frame,Horizontal,InversGrad:boolean);
var   hdcMem:HDC;
      hdcBmp:HBITMAP;
      hWidth,hHeight:integer;
      vert: array[0..1] of TTriVertex;
      gRect: TGradientRect;
begin
   with Sender{$ifndef F_P}^{$endif} do begin
      hWidth:= cbRect.Right - cbRect.Left;
      hHeight:= cbRect.Bottom - cbRect.Top;
      hdcMem:= CreateCompatibleDC(0);
      hdcBmp:= CreateCompatibleBitmap(DC,hWidth,hHeight);
      SelectObject(hdcMem, hdcBmp);

      StartColor := Color2RGB(StartColor);
      EndColor := Color2RGB(EndColor); 

      if Gradient then
         StartColor:= GetLightColor(StartColor, max(0,min(100,DepthGradient)))
      else
         EndColor := StartColor; 
       
      if Frame then begin
         vert[0].x      := 1;
         vert[0].y      := 1;
         vert[1].x      := hWidth-1;
         vert[1].y      := hHeight-1;
         Canvas.Brush.Color:= Color2RGB(ColorFrame);
         FillRect(hdcMem,MakeRect(0,0,hWidth,hHeight),Canvas.Brush.Handle);
      end else begin
         vert[0].x      := 0;
         vert[0].y      := 0;
         vert[1].x      := hWidth;
         vert[1].y      := hHeight;
      end;
      vert[0].Alpha  := $ff00; // ???
      vert[1].Alpha  := vert[0].Alpha;  

      if not InversGrad then begin
         vert[0].Red    := GetRValue(StartColor) shl 8;
         vert[0].Green  := GetGValue(StartColor) shl 8;
         vert[0].Blue   := GetBValue(StartColor) shl 8;
         vert[1].Red    := GetRValue(EndColor) shl 8;
         vert[1].Green  := GetGValue(EndColor) shl 8;
         vert[1].Blue   := GetBValue(EndColor) shl 8;
      end else begin
         vert[1].Red    := GetRValue(StartColor) shl 8;
         vert[1].Green  := GetGValue(StartColor) shl 8;
         vert[1].Blue   := GetBValue(StartColor) shl 8;
         vert[0].Red    := GetRValue(EndColor) shl 8;
         vert[0].Green  := GetGValue(EndColor) shl 8;
         vert[0].Blue   := GetBValue(EndColor) shl 8;
      end;

      gRect.UpperLeft  := 0;
      gRect.LowerRight := 1;

      if Horizontal then
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_H)
      else
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_V);
      BitBlt(DC, cbRect.Left, cbRect.Top, hWidth, hHeight, hdcMem, 0, 0, SRCCOPY);
      DeleteDC(hdcMem);
      DeleteObject(hdcBmp);
   end;
end;

//******************************************************************************

function ScaleImage(Sender:PControl; bitmap:HBITMAP; ImgSize:integer; mode:byte):HBITMAP;
var   nbmp,bmp,bmprect:PBitmap;
      sw,nw,ih:integer;
      i:integer;
begin
   Result:= 0;
   case mode of
      NONE: exit;
      SCALE: exit;
      GRADIENT: exit;
      MOSAIC: begin
         ih:= max(ImgSize, Sender.Canvas.TextExtent('W').cy);
         bmprect:= NewDIBBitmap(1,1,pf32bit);
         bmprect.handle:= CopyImage(bitmap,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
         nw:= max(Sender.Width*bmprect.height*100 div (bmprect.width*ih) + 200,1);
         sw:= (nw*bmprect.width*ih div bmprect.height) div 100;
         nbmp:= NewDIBBitmap(sw,ih,pf32bit);
         bmp:= NewDIBBitmap(bmprect.width*ih div bmprect.height,ih,pf32bit);
         SetStretchBltMode(bmp.Canvas.Handle, HALFTONE);
         bmprect.StretchDraw(bmp.canvas.handle,bmp.BoundsRect);
         i:= 0;
         repeat
            BitBlt(nbmp.Canvas.Handle,i*bmp.width,0,sw,ih,bmp.canvas.handle,0,0,SRCCOPY);
            inc(i);
         until i = nw;
         Result:= CopyImage(nbmp.handle,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
         bmprect.free;
         nbmp.free;
         bmp.free;
      end;
   end;
end;

procedure ThiColorBoxEx._work_doFormatColor;begin   fFormatColor:= ToInteger(_Data);end;
procedure ThiColorBoxEx._work_doFullColor;begin     fFullColor:= ReadBool(_Data);InitList;end;
procedure ThiColorBoxEx._work_doGradient;begin      fGradient:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doInversClrTxt;begin  fInversClrTxt:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doInversGrad;begin    fInversGrad:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doFrame;begin         fFrame:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doDarkColor;begin     fDarkColor:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doLightColor;begin    fLightColor:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doHorizontal;begin    fHorizontal:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doColorFrame;begin    fColorFrame:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doBumpText;begin      fBumpText:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doDarkClrBack;begin   fDarkClrBack:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doLightClrBack;begin  fLightClrBack:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doInversBack;begin    fInversBack:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doDepthGradient;begin fDepthGradient:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doDepthBack;begin     fDepthBack:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiColorBoxEx._work_doBackgroundImg;
begin
   if not _IsBitmap(_Data) then exit;
   fBackgroundImg:= CopyImage(ToBitmap(_Data).handle,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
   InitBackgroundImg;
end;
procedure ThiColorBoxEx._work_doScaleImage;
begin
   fScaleImage:= ToIntIndex(_Data);
   InitBackgroundImg;
end;

procedure ThiColorBoxEx.InitBackgroundImg;
begin
   if (fBackgroundImg = 0) then exit;
   DeleteObject(BackgroundImg);
   BackgroundImg:= ScaleImage(Control, fBackgroundImg, fColorSize + fIndentImg*2, fScaleImage);   
   Control.Invalidate;
end;

//------------------------       ----------------------

procedure ThiColorBoxEx.Init;
var   Flags:TComboOptions;
begin
   Flags := [coNoIntegralHeight, coReadOnly, coOwnerDrawFixed];
   ColorSize:= max(fColorSize + fIndentImg*2,fColorSize);
   Control := NewComboBox(FParent,Flags);
   Control.OnSelChange := _OnClick;
   Control.OnMeasureItem:= _OnMeasureItem;
   Control.OnDrawItem:= _OnDrawItem;

inherited;
   InitList;
   InitBackgroundImg;
   _OnResize(Control);
end;

procedure ThiColorBoxEx.InitList;
var   i:integer;
      str:string;
      valid:boolean;
      CList:PStrList;
begin
   Control.Clear;
   if not fCustomColors then begin
      if fFullColor then ColorRange:= FullColor else ColorRange:= 16; 
      str:= '';
      for i:= 0 to ColorRange - 1 do str:= str + ColorNames[i] + #13#10;
      SetStrings(str);
      for i:= 0 to ColorRange - 1 do Control.ItemData[i]:= Color2RGB(ColorValues[i]);
   end;
   CList:= NewStrList;
   CList.text:= fColors;
   if CList.Count <> 0 then
      for i:=0 to CList.Count - 1 do begin
         str:= CList.Items[i] + '=';
         Add(gettok(str,'='));
         Control.ItemData[Control.Count - 1]:= str2int(gettok(str,'=')); 
      end; 
   CList.free; 
   valid:= false;
   ColorRange:= Control.Count;
   Control.CurIndex := 0;
   for i:= 0 to ColorRange - 1 do 
      if Control.ItemData[i] = dword(Color2RGB(fDefColor)) then begin
         valid:= true;
         break;
      end;
   if not valid then exit;
   Control.CurIndex := i;
   Control.Invalidate;
end;
      
destructor ThiColorBoxEx.Destroy;
begin
   if ColorArr <> nil then Dispose(ColorArr);
   DeleteObject(BackgroundImg);
   FreeData(@FData); 
   inherited Destroy;
end;

procedure ThiColorBoxEx._OnResize;
begin
   inherited;
   InitBackgroundImg;
end;

procedure ThiColorBoxEx._OnClick;
var   dr,dg,db:TData;
      fFrom: TRGB;
begin
   inherited;
   case _prop_DataType of
      0: _hi_OnEvent(_event_onClick, Control.CurIndex);
      1: begin
            case fFormatColor of
               0: _hi_OnEvent(_event_onClick, integer(Control.ItemData[Control.CurIndex]));
               1: _hi_OnEvent(_event_onClick, RGB2HTML(Control.ItemData[Control.CurIndex]));
               2: begin
                     fFrom := TRGB(Control.ItemData[Control.CurIndex]);
                     dtInteger(dr, FFrom.R);
                     dtInteger(dg, FFrom.G);
                     dr.ldata:= @dg;
                     dtInteger(db, FFrom.B);
                     dg.ldata:= @db;
                     _hi_onEvent_(_event_onClick, dr);                
                  end;
            end;
         end;
   end;
end;

function ThiColorBoxEx._OnMeasureItem;
var   fControl: PControl;
begin
   fControl:= PControl(Sender);
   Result:= max(ColorSize, fControl.Canvas.TextExtent('W').cy);
end;

//---------------------       -----------------------

function ThiColorBoxEx._OnDrawItem;
const   SHIFT_PICTURE = 6;

var     fControl: PControl;
        ARect,BRect,cbRect: TRect;
        _Flags: dword;
        hdcMem: HDC;
        dx,dy:integer;
begin
   Result:= False;
   fControl:= PControl(Sender);

   with fControl{$ifndef F_P}^{$endif} do begin
      if (Rect.Bottom - Rect.Top > Height) then exit;
         dx:= Rect.Right - Rect.Left;
         dy:= Rect.Bottom - Rect.Top;
         if (fScaleImage <> GRADIENT) and (fBackgroundImg <> 0) then begin
            hdcMem:= CreateCompatibleDC(0);
            SelectObject(hdcMem, BackgroundImg);
            BitBlt(DC, 0, Rect.Top, dx, dy, hdcMem, 0, 0, SRCCOPY);
            DeleteDC(hdcMem);
         end
         else if (fScaleImage = GRADIENT) then
            _Gradient(fControl,DC,Rect,true,fDepthBack,fLightClrBack,
                      fDarkClrBack,0,false,true,fInversBack);         

         if (Itemidx = Count - 1) then begin
            cbRect:= Rect;
            cbRect.Top:= cbRect.Bottom;
            cbRect.Bottom:= cbRect.Bottom + dy;            
            if (fScaleImage <> GRADIENT) and (fBackgroundImg <> 0) then begin
               hdcMem:= CreateCompatibleDC(0);
               SelectObject(hdcMem, BackgroundImg);
               BitBlt(DC, cbRect.Left, cbRect.Top, dx, dy, hdcMem, 0, 0, SRCCOPY);
               DeleteDC(hdcMem);               
            end
            else if (fScaleImage = GRADIENT) and not (odsComboboxEdit in ItemState) then begin
               _Gradient(fControl,DC,cbRect,true,fDepthBack,fLightClrBack,
                         fDarkClrBack,0,false,true,fInversBack); 
            end;
         end; 

      cbRect:= Rect;
      
      if (odsSelected in ItemState) then
         _Gradient(fControl,DC,cbRect,fGradient,fDepthGradient,fLightColor,fDarkColor,
                   fColorFrame,fFrame,fHorizontal,fInversGrad)
      else begin
         if ((fBackgroundImg = 0) or (fScaleImage = NONE)) and (fScaleImage <> GRADIENT) then begin
            Canvas.Brush.Color:= Color;
            FillRect(DC,cbRect,Canvas.Brush.Handle);
         end;
      end;

      ARect:= Rect;
      ARect.Left:= ARect.Left + fColorSize*2 + Canvas.TextExtent('W').cx;
      if (odsComboboxEdit in ItemState) then ARect.Left:= ARect.Left - 3;
      BRect:= ARect; 
      inc(BRect.Left); inc(BRect.Top); inc(BRect.Right); inc(BRect.Bottom);
      SetTextColor(DC,Color2RGB(Font.Color));
      SetBkMode(DC, Font.Color);

      _Flags:=  DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX;  

      if fBumpText then begin
         if (odsSelected in ItemState) and fGradient then begin
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clBackground))
            else
               SetTextColor(DC,Color2RGB(clHighlightText));
            DrawText(DC, PChar(Items[ItemIdx]), -1, BRect, _Flags);
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color));
         end
         else if not (odsSelected in ItemState) and (fScaleImage = GRADIENT) then begin
            SetTextColor(DC,Color2RGB(clBackground));
            DrawText(DC, PChar(Items[ItemIdx]), -1, BRect, _Flags);
            SetTextColor(DC,Color2RGB(clHighlightText));
         end
         else
            SetTextColor(DC,Color2RGB(Font.Color));
      end
      else if (odsSelected in ItemState) then begin
            if fInversClrTxt then
               SetTextColor(DC,Color2RGB(clHighlightText))
            else
               SetTextColor(DC,Color2RGB(Font.Color));
         end
         else
            SetTextColor(DC,Color2RGB(Font.Color));

      DrawText(DC, PChar(Items[ItemIdx]), -1, ARect, _Flags);
      Result:= True;

      with cbRect do begin
         Top:= Top + (Bottom - Top - fColorSize) div 2;
         Left:= SHIFT_PICTURE;
         Bottom:= Top + fColorSize; 
         Right:= Left + fColorSize*2;
      end;
      Canvas.Brush.Color := Color2RGB(clBlack);
      FillRect(DC,cbRect,Canvas.Brush.Handle);
      Canvas.Brush.Color := ItemData[ItemIdx];
      FillRect(DC,MakeRect(cbRect.Left+1,cbRect.Top+1,cbRect.Right-1,cbRect.Bottom-1),Canvas.Brush.Handle);
   end;
end;

//------------------         --------------------

procedure ThiColorBoxEx._var_ColorArray;
begin
  if ColorArr = nil then
    ColorArr := CreateArray(nil,_val_arr_get,_val_arr_count,nil);
  dtArray(_Data, ColorArr);
end;

function ThiColorBoxEx._val_arr_get;
var   ind:integer;
begin
  ind := ToIntIndex(Item);
  Result := (ind >=0 )and(ind < Control.Count);
  if Result then dtInteger(Val,Control.ItemData[ind]);
end;

function ThiColorBoxEx._val_arr_count;
begin
  Result := Control.Count;
end;

procedure ThiColorBoxEx._var_Index;
begin
   dtInteger(_Data, Control.CurIndex);
end;

procedure ThiColorBoxEx._var_CurrentColor;
var   dr,dg,db:TData;
      fFrom: TRGB;
begin
   case fFormatColor of
      0: dtInteger(_Data, integer(Control.ItemData[Control.CurIndex]));
      1: dtString(_Data, RGB2HTML(Control.ItemData[Control.CurIndex]));
      2: begin
            fFrom := TRGB(Control.ItemData[Control.CurIndex]);
            FreeData(@FData);
            dtNull(FData);
            dtInteger(dr,FFrom.R);
            dtInteger(dg,FFrom.G);
            dtInteger(db,FFrom.B);
            dr.ldata := @dg;
            dg.ldata := @db;
            CopyData(@FData,@dr);
            _Data := FData;
         end;
   end;
end;

procedure ThiColorBoxEx._work_doSelectColor;
var   Clr: TColor;
      i:integer;
      valid:boolean;
begin
   Clr:= ReadInteger(_Data, _data_Value, _prop_DefColor);
   valid:= false;
   for i:= 0 to ColorRange - 1 do 
      if Control.ItemData[i] = dword(Color2RGB(Clr)) then begin
         valid:= true;
         break;
      end;
   if not valid then exit;
   Control.CurIndex := i;
   Control.Invalidate;
end;

procedure ThiColorBoxEx._work_doSelectName;
var   Clr: string;
      i:integer;
      valid:boolean;
begin
   Clr:= ToString(_Data);
   Replace(Clr,'cl','');
   valid:= false;
   for i:= 0 to ColorRange - 1 do 
      if Control.Items[i] = Clr then begin
         valid:= true;
         break;
      end;
   if not valid then exit;
   Control.CurIndex := i;
   Control.Invalidate;
end;

end.